;
; cos𓾂
;
; 
; A:px
;
; o
; F:j
; A:cos(A)127{l
;
cos::
	add #64

;
; sin𓾂
;
; 
; A:px
;
; o
; F:j
; A:sin(A)127{l
;
sin::
	; if r = 0 then return 0
	or A
	jr Z, sin_0

	; if r = 180 then return 0
	cp #-128
	jr Z, sin_0

	; if r = 90 then return 1
	cp #64
	jr Z, sin_90
	
	; if r = 270 then return -1
	cp #192
	jr Z, sin_270

	push BC
	push AF
sin0:
	; if 0 <= r < 90 then r' = r
	sub #64
	jr NC, sin1
	add #64
	jr sin_skip
sin1:
	; if 90 <= r < 180 then r' = 180 - r
	sub #64
	jr NC, sin2
	neg
	jr sin_skip
sin2:
	; if 180 <= r < 270 then r' = r - 180
	sub #64
	jr NC, sin3
	add #64
	jr sin_skip
sin3:
	; if 270 <= r < 360 then r' = 360 - r
	sub #64
	neg

sin_skip:
	; if r < 180 then return sin_table[r'] else return -sin_table[r']
	push HL
	ld HL, #sin_table
	ld B, #0
	ld C, A
	add HL, BC
	ld C, (HL)
	pop HL

	pop AF
	cp #128
	ld A, C
	pop BC

	ret C
	neg
	ret

sin_0:
	xor A
	ret

sin_90:
	ld A, #127
	ret

sin_270:
	ld A, #-127
	ret

sin_table:
	.db 0 ; sin(0)
	.db 3 ; sin(1)
	.db 6 ; sin(2)
	.db 9 ; sin(4)
	.db 12 ; sin(5)
	.db 15 ; sin(7)
	.db 18 ; sin(8)
	.db 21 ; sin(9)
	.db 24 ; sin(11)
	.db 27 ; sin(12)
	.db 30 ; sin(14)
	.db 33 ; sin(15)
	.db 36 ; sin(16)
	.db 39 ; sin(18)
	.db 42 ; sin(19)
	.db 45 ; sin(21)
	.db 48 ; sin(22)
	.db 51 ; sin(23)
	.db 54 ; sin(25)
	.db 57 ; sin(26)
	.db 59 ; sin(28)
	.db 62 ; sin(29)
	.db 65 ; sin(30)
	.db 67 ; sin(32)
	.db 70 ; sin(33)
	.db 73 ; sin(35)
	.db 75 ; sin(36)
	.db 78 ; sin(37)
	.db 80 ; sin(39)
	.db 82 ; sin(40)
	.db 85 ; sin(42)
	.db 87 ; sin(43)
	.db 89 ; sin(45)
	.db 91 ; sin(46)
	.db 94 ; sin(47)
	.db 96 ; sin(49)
	.db 98 ; sin(50)
	.db 100 ; sin(52)
	.db 102 ; sin(53)
	.db 103 ; sin(54)
	.db 105 ; sin(56)
	.db 107 ; sin(57)
	.db 108 ; sin(59)
	.db 110 ; sin(60)
	.db 112 ; sin(61)
	.db 113 ; sin(63)
	.db 114 ; sin(64)
	.db 116 ; sin(66)
	.db 117 ; sin(67)
	.db 118 ; sin(68)
	.db 119 ; sin(70)
	.db 120 ; sin(71)
	.db 121 ; sin(73)
	.db 122 ; sin(74)
	.db 123 ; sin(75)
	.db 123 ; sin(77)
	.db 124 ; sin(78)
	.db 125 ; sin(80)
	.db 125 ; sin(81)
	.db 126 ; sin(82)
	.db 126 ; sin(84)
	.db 126 ; sin(85)
	.db 126 ; sin(87)
	.db 126 ; sin(88)
	.db 126 ; sin(90)

;
; Copyright 2011 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

; eof
